#!/usr/bin/python

import os, sys
from optparse import OptionParser

from pysqlite2 import dbapi2 as sqlite
#import sqlite

usage = "usage: %prog -i [dbfile] [options]"
version = "1.0 by Garrett Gee <garrett - at - garrettgee.com>"
parser = OptionParser(usage=usage,version=version)
parser.add_option("-i", "--inputfile", dest="inputfile", help="dat input file")
parser.add_option("-o", "--outputfile", dest="outputfile", help="if not defined, will create txt file based on filename")
parser.add_option("-v", "--verbose", action="store_true", dest="verbose", help="")
parser.add_option("-d", "--debug", action="store_true", dest="debug", help="")

(options, args) = parser.parse_args()

if (not (options.inputfile)) or (not os.path.isfile(options.inputfile)):
    parser.print_help()
    sys.exit()

dbfile = options.inputfile
txtfile = options.outputfile
verbose = options.verbose
debug = options.debug
#------------------------------------------
if not (txtfile):
    (txtfile,ext) = os.path.splitext(dbfile)
    txtfile = txtfile + "-ports.html"
    
if debug:
    print "Inputfile: " + dbfile    
    print "Outputfile: " + txtfile

if os.path.isfile(txtfile):
    ##this should be a choice box
    print "Removing old " + txtfile
    os.remove(txtfile)    
#------------------------------------------
cx = sqlite.connect(dbfile)
cu = cx.cursor()

fh = open(txtfile, "a")

fh.write("<b>Open Ports table</b><br>\n")
fh.write("<table border=\"1\"><tr><th>IP</th><th>Open TCP</th><th>Open UDP</th>\n")
fh.write("<tr><td>")
cu.execute("select distinct IP from nessus order by IP asc")
res = cu.fetchall()
for row_ip in res:
    ip = row_ip[0]
    #TCP
    cu.execute("select distinct port from nessus where IP = ? and protocol = \"tcp\" and port != \"\"", (ip,))
    res_tcp = cu.fetchall()
    tcplist = ""
    first = 1
    for row_tcp in res_tcp:
        port = str(row_tcp[0])
        if first:
            tcplist = port
            first = 0
        else:
            tcplist = tcplist + ", " + port
    if tcplist == "":
        tcplist = "None"
    #UDP
    cu.execute("select distinct port from nessus where IP = ? and protocol = \"udp\" and port != \"\"", (ip,))
    res_udp = cu.fetchall()
    udplist = ""
    first = 1
    for row_udp in res_udp:
        port = str(row_udp[0])
        if first:
            udplist = port
            first = 0
        else:
            udplist = udplist + ", " + port
    if udplist == "":
        udplist = "None"                
    
    #line = ip + "|" + tcplist + "|" + udplist
    fh.write("<tr><td>" + ip + "</td><td>" + tcplist + "</td><td>" + udplist + "</td></tr>\n")
fh.write("</td>\n")
fh.write("</tr>")
fh.write("</table>")
fh.write("<br>\n\n")

fh.close()