#!/usr/bin/python

import os, re, string, sys
from optparse import OptionParser

from pysqlite2 import dbapi2 as sqlite
#import sqlite

usage = "usage: %prog -i [dbfile] [options]"
version = "1.1 by Garrett Gee <garrett - at - garrettgee.com>"
parser = OptionParser(usage=usage,version=version)
parser.add_option("-i", "--inputfile", dest="inputfile", help="dat input file")
parser.add_option("-o", "--outputfile", dest="outputfile", help="if not defined, will create html file based on filename")
parser.add_option("-v", "--verbose", action="store_true", dest="verbose", help="")
parser.add_option("-d", "--debug", action="store_true", dest="debug", help="")

(options, args) = parser.parse_args()

if (not (options.inputfile)) or (not os.path.isfile(options.inputfile)):
    parser.print_help()
    sys.exit()

dbfile = options.inputfile
txtfile = options.outputfile
verbose = options.verbose
debug = options.debug
#------------------------------------------
if not (txtfile):
    (txtfile,ext) = os.path.splitext(dbfile)
    txtfile = txtfile + "-unsorted.html"
    
if debug:
    print "Inputfile: " + dbfile    
    print "Outputfile: " + txtfile

if os.path.isfile(txtfile):
    ##this should be a choice box
    print "Removing old " + txtfile
    os.remove(txtfile)    
#------------------------------------------
cx = sqlite.connect(dbfile)
cu = cx.cursor()

fh = open(txtfile, "a")
fh.write("<html><head><title>Unsorted Nessus Vulns Report for " + dbfile + "</title></head><body>\n\n")
fh.write("SevLevel Types nessus 4.0 and lower: Security Hole | Security Warning | Security Note<br>\n")
fh.write("SevLevel Types nessus 4.2 and newner: security_hole | security_warning | security_note<br><br>\n")

##need to sort ids based on sevlevel - this doesnt work very well since they are strings
##resort the list after filtered?
cu.execute("select distinct pluginid from nessus order by sevlevel;")
res = cu.fetchall()
ids = {}
for i in res:
    i = str(i[0])
    ids[i] = i
    
#print len(allids.keys())
 
##make this into an optional file
nessusids = open("nessusids.txt", "r")
for row in nessusids:
    row = re.sub("\n", "", row)
    if ids.has_key(row):
        del ids[row]

#print len(allids.keys())

##need a trigger to sql query limit 3 = good for debugging

for i in ids:
    cu.execute("select IP, port, notes, sevlevel from nessus where pluginid=\"" + i + "\" order by IP;")
    #cu.execute("select IP, port, notes, sevlevel from nessus where pluginid=\"" + i + "\" order by IP limit 3;")
    res = cu.fetchall()
    if res:
        fh.write("<b>Nessus ID: " + i + "</b>" + " | Severity: " + row[3] + "<br>\n")
        descr = res[0][2]
        descr = string.split(descr, "\\n\\n")
        max = len(descr)-4
        descr = descr[0:max]
        descr2 = ""
        for i in descr:
            descr2 = descr2 + i
        fh.write(descr2 + "<br>\n")
        devices = []
        data = []
        
        for row in res:
            ip = row[0]
            port = str(row[1])
            notes = row[2]
            
            devices.append(ip + ":" + port)
            
            support = string.split(notes, "\\n\\n")
            support = support[-2:]
            data.append(ip + ":" + port + " - " + str(support))
        
        fh.write("<table border=\"1\"><tr><th>" + str(len(devices)) + " devices</th><th>supporting data</th>\n")
        fh.write("<tr><td>")
        for i in devices:
            fh.write(i + "<br>")
        fh.write("</td>\n")
        fh.write("<td>")
        for i in data:
            fh.write(i + "<br>")
        fh.write("</td>\n")
        fh.write("</tr>")
        fh.write("</table>")
        fh.write("<br>\n\n")

fh.write("</body></html>")
fh.close()

